Index: django.po
===================================================================
--- django.po	(revision 2979)
+++ django.po	(working copy)
@@ -72,7 +72,7 @@
 
 #: contrib/comments/models.py:84 contrib/comments/models.py:170
 msgid "is public"
-msgstr "is publiek"
+msgstr "is openbaar"
 
 #: contrib/comments/models.py:85 contrib/admin/views/doc.py:289
 msgid "IP address"
@@ -123,7 +123,7 @@
 
 #: contrib/comments/models.py:173
 msgid "approved by staff"
-msgstr "goegekeurd door de staf"
+msgstr "goedgekeurd door de staf"
 
 #: contrib/comments/models.py:176
 msgid "free comment"
@@ -209,13 +209,13 @@
 
 #: contrib/comments/views/karma.py:25
 msgid "No voting for yourself"
-msgstr "Niet op jezelf stemmen"
+msgstr "Niet op uwzelf stemmen"
 
 #: contrib/comments/views/comments.py:28
 msgid ""
 "This rating is required because you've entered at least one other rating."
 msgstr ""
-"Deze waardering is verplicht omdat je op zijn minst een andere waardering "
+"Deze waardering is verplicht omdat u tenminste één andere waardering "
 "hebt ingevoerd."
 
 #: contrib/comments/views/comments.py:112
@@ -231,13 +231,13 @@
 "\n"
 "%(text)s"
 msgstr[0] ""
-"Deze opmerking is gepost door een gebruiker welke minder dan %(count)s heeft "
-"gepostopmerking:\n"
+"Deze opmerking is gepost door een gebruiker die minder dan %(count)s "
+"opmerking heeft gepost:\n"
 "\n"
 "%(text)s"
 msgstr[1] ""
-"Deze opmerking is gepost door een gebruiker welke minder dan %(count)s heeft "
-"gepostopmerkingen:\n"
+"Deze opmerking is gepost door een gebruiker die minder dan %(count)s "
+"opmerkingen heeft gepost:\n"
 "\n"
 "%(text)s"
 
@@ -260,7 +260,7 @@
 #: contrib/comments/views/comments.py:193
 #: contrib/comments/views/comments.py:284
 msgid "One or more of the required fields wasn't submitted"
-msgstr "Een of meerdere verplichte velden is niet ingevuld"
+msgstr "Een of meerdere verplichte velden zijn niet ingevuld"
 
 #: contrib/comments/views/comments.py:197
 #: contrib/comments/views/comments.py:286
@@ -454,9 +454,8 @@
 "Looks like your browser isn't configured to accept cookies. Please enable "
 "cookies, reload this page, and try again."
 msgstr ""
-"Lijkt erop dat uw browser geen cookies accepteerd. Zet het gebruik van "
-"cookies aan in uw browser, en laad deze pagina nogmaals en probeer het "
-"opnieuw."
+"Het lijkt erop dat uw browser geen cookies accepteerd. Zet het gebruik van "
+"cookies aan in uw browser, laad deze pagina nogmaals en probeer het opnieuw."
 
 #: contrib/admin/views/decorators.py:82
 msgid "Usernames cannot contain the '@' character."
@@ -465,7 +464,7 @@
 #: contrib/admin/views/decorators.py:84
 #, python-format
 msgid "Your e-mail address is not your username. Try '%s' instead."
-msgstr "Uw e-mail adres is niet uw gebruikersnaam. Probeer '%s' eens."
+msgstr "Uw e-mailadres is niet uw gebruikersnaam. Probeer '%s' eens."
 
 #: contrib/admin/views/main.py:226
 msgid "Site administration"
@@ -517,7 +516,7 @@
 #: contrib/admin/views/main.py:346
 #, python-format
 msgid "The %(name)s \"%(obj)s\" was changed successfully."
-msgstr "Wijzigen %(name)s \"%(obj)s\" is geslaagd."
+msgstr "Het wijzigen van %(name)s \"%(obj)s\" is geslaagd."
 
 #: contrib/admin/views/main.py:354
 #, python-format
@@ -552,7 +551,7 @@
 #: contrib/admin/views/main.py:533
 #, python-format
 msgid "Change history: %s"
-msgstr "Wijzigingshistorie: %s"
+msgstr "Wijzigingsgeschiedenis: %s"
 
 #: contrib/admin/views/main.py:565
 #, python-format
@@ -577,7 +576,7 @@
 #: contrib/admin/views/doc.py:279 contrib/admin/views/doc.py:296
 #, python-format
 msgid "String (up to %(maxlength)s)"
-msgstr "Karakterreeks (maximaal %(maxlength)s)"
+msgstr "Karakterreeks (hooguit %(maxlength)s)"
 
 #: contrib/admin/views/doc.py:280
 msgid "Comma-separated integers"
@@ -707,8 +706,8 @@
 "This object doesn't have a change history. It probably wasn't added via this "
 "admin site."
 msgstr ""
-"Dit object heeft geen geschiedenis. Mogelijk niet via de admin site "
-"toegevoegd."
+"Dit object heeft geen wijzigingsgeschiedenis. Het is mogelijk niet via de "
+"admin site toegevoegd."
 
 #: contrib/admin/templates/admin/base_site.html:4
 msgid "Django site admin"
@@ -735,8 +734,8 @@
 "There's been an error. It's been reported to the site administrators via e-"
 "mail and should be fixed shortly. Thanks for your patience."
 msgstr ""
-"Er is een fout geweest. Dit is inmiddels doorgegevens aan de sitebeheerder "
-"via e-mail en zal binnenkort worden gerepareerd. Bedankt voor uw geduld"
+"Er is een fout opgetreden. Dit is inmiddels doorgegeven aan de sitebeheerder "
+"via e-mail en zal spoedig worden gerepareerd. Bedankt voor uw geduld."
 
 #: contrib/admin/templates/admin/404.html:4
 #: contrib/admin/templates/admin/404.html:8
@@ -745,7 +744,7 @@
 
 #: contrib/admin/templates/admin/404.html:10
 msgid "We're sorry, but the requested page could not be found."
-msgstr "De gevraagde pagina komt niet voor."
+msgstr "Onze excuses, maar de gevraagde pagina komt niet voor."
 
 #: contrib/admin/templates/admin/index.html:17
 #, python-format
@@ -802,9 +801,9 @@
 "objects, but your account doesn't have permission to delete the following "
 "types of objects:"
 msgstr ""
-"Verwijderen van %(object_name)s '%(object)s' zal ook gerelateerde objecten "
-"verwijderen. Echter u heeft geen rechten om de volgende typen objecten te "
-"verwijderen:"
+"Het verwijderen van %(object_name)s '%(object)s' zal ook gerelateerde "
+"objecten verwijderen. Echter u heeft geen rechten om de volgende typen "
+"objecten te verwijderen:"
 
 #: contrib/admin/templates/admin/delete_confirmation.html:21
 #, python-format
@@ -890,12 +889,12 @@
 "Forgotten your password? Enter your e-mail address below, and we'll reset "
 "your password and e-mail the new one to you."
 msgstr ""
-"Wachtwoord vergeten? Geef u e-mail adres op en we herstellen uw wachtwoord "
-"en zullen een nieuwe toesturen."
+"Uw wachtwoord vergeten? Geef uw e-mailadres op en er zal een nieuw "
+"wachtwoord worden toegekend en aan u worden toegezonden."
 
 #: contrib/admin/templates/registration/password_reset_form.html:16
 msgid "E-mail address:"
-msgstr "E-mail adres:"
+msgstr "E-mailadres:"
 
 #: contrib/admin/templates/registration/password_reset_form.html:16
 msgid "Reset my password"
@@ -919,15 +918,15 @@
 "We've e-mailed a new password to the e-mail address you submitted. You "
 "should be receiving it shortly."
 msgstr ""
-"Een nieuw wachtwoord is per e-mail verstuurd. U zult het straks ontvangen."
+"Een nieuw wachtwoord is per e-mail verstuurd. U zult het spoedig ontvangen."
 
 #: contrib/admin/templates/registration/password_change_form.html:12
 msgid ""
 "Please enter your old password, for security's sake, and then enter your new "
 "password twice so we can verify you typed it in correctly."
 msgstr ""
-"Vanwege de beveiliging geef uw oude wachtwword op en twee keer een nieuwe, "
-"zodat we kunnen controleren of er geen typefouten zijn gemaakt."
+"Vanwege de beveiliging moet u uw oude en twee keer een nieuw wachtwoord"
+"invoeren, zodat we kunnen controleren of er geen typefouten zijn gemaakt."
 
 #: contrib/admin/templates/registration/password_change_form.html:17
 msgid "Old password:"
@@ -947,7 +946,7 @@
 
 #: contrib/admin/templates/registration/password_reset_email.html:2
 msgid "You're receiving this e-mail because you requested a password reset"
-msgstr "U krijgt een e-mail omdat u om een nieuw wachtwoord heeft gevraagd"
+msgstr "U krijgt deze e-mail omdat u om een nieuw wachtwoord heeft gevraagd"
 
 #: contrib/admin/templates/registration/password_reset_email.html:3
 #, python-format
@@ -1044,7 +1043,7 @@
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:29
 msgid "As above, but opens the admin page in a new window."
-msgstr "Als boven, maar opent de beheerpagina in een nieuw venster."
+msgstr "Zoals hierboven, maar opent de beheerpagina in een nieuw venster."
 
 #: contrib/admin/templates/widget/date_time.html:3
 msgid "Date:"
@@ -1083,8 +1082,8 @@
 "This can be either an absolute path (as above) or a full URL starting with "
 "'http://'."
 msgstr ""
-"Dit kan een absoluut pad (zoals boven) of een volledige URL beginnend met "
-"'http://'."
+"Dit kan een absoluut pad (zoals hierboven) zijn of een volledige URL "
+"beginnend met 'http://'."
 
 #: contrib/redirects/models.py:12
 msgid "redirect"
@@ -1097,7 +1096,8 @@
 #: contrib/flatpages/models.py:8
 msgid ""
 "Example: '/about/contact/'. Make sure to have leading and trailing slashes."
-msgstr "Voorbeeld: '/about/contact/'. Zorg voor slashes aan begin en eind"
+msgstr ""
+"Voorbeeld: '/about/contact/'. Zorg voor slashes aan het begin en eind."
 
 #: contrib/flatpages/models.py:9
 msgid "title"
@@ -1130,8 +1130,8 @@
 #: contrib/flatpages/models.py:14
 msgid "If this is checked, only logged-in users will be able to view the page."
 msgstr ""
-"Alleen ingelogde gebruikers kunnen deze pagina zien, indien dit is "
-"aangekruist."
+"Indien dit is aangekruist kunnen alleen ingelogde gebruikers deze pagina "
+"bekijken."
 
 #: contrib/flatpages/models.py:18
 msgid "flat page"
@@ -1167,7 +1167,7 @@
 
 #: contrib/auth/models.py:55
 msgid "username"
-msgstr "gebruikernaam"
+msgstr "gebruikersnaam"
 
 #: contrib/auth/models.py:56
 msgid "first name"
@@ -1195,7 +1195,7 @@
 
 #: contrib/auth/models.py:60
 msgid "Designates whether the user can log into this admin site."
-msgstr "Bepaalt of gebruiker kan inloggen op deze admin site"
+msgstr "Bepaalt of de gebruiker kan inloggen op deze admin site."
 
 #: contrib/auth/models.py:61
 msgid "active"
@@ -1258,8 +1258,8 @@
 "Your Web browser doesn't appear to have cookies enabled. Cookies are "
 "required for logging in."
 msgstr ""
-"Lijkt erop dat uw browser geen cookies accepteerd. Om aan te melden moeten "
-"cookies worden geaccepteerd."
+"Het lijkt erop dat uw browser geen cookies accepteerd. Om aan te melden "
+"moeten cookies worden geaccepteerd."
 
 #: contrib/contenttypes/models.py:25
 msgid "python model class name"
@@ -1267,11 +1267,11 @@
 
 #: contrib/contenttypes/models.py:28
 msgid "content type"
-msgstr "inhoudtype"
+msgstr "inhoudstype"
 
 #: contrib/contenttypes/models.py:29
 msgid "content types"
-msgstr "inhoudtypen"
+msgstr "inhoudstypen"
 
 #: contrib/sessions/models.py:35
 msgid "session key"
@@ -1323,31 +1323,31 @@
 
 #: utils/dates.py:6
 msgid "Monday"
-msgstr "Maandag"
+msgstr "maandag"
 
 #: utils/dates.py:6
 msgid "Tuesday"
-msgstr "Dinsdag"
+msgstr "dinsdag"
 
 #: utils/dates.py:6
 msgid "Wednesday"
-msgstr "Woensdag"
+msgstr "woensdag"
 
 #: utils/dates.py:6
 msgid "Thursday"
-msgstr "Donderdag"
+msgstr "donderdag"
 
 #: utils/dates.py:6
 msgid "Friday"
-msgstr "Vrijdag"
+msgstr "vrijdag"
 
 #: utils/dates.py:7
 msgid "Saturday"
-msgstr "Zaterdag"
+msgstr "zaterdag"
 
 #: utils/dates.py:7
 msgid "Sunday"
-msgstr "Zondag"
+msgstr "zondag"
 
 #: utils/dates.py:14
 msgid "January"
@@ -1400,52 +1400,52 @@
 #: utils/dates.py:19
 #, fuzzy
 msgid "jan"
-msgstr "en"
+msgstr "jan"
 
 #: utils/dates.py:19
 msgid "feb"
-msgstr ""
+msgstr "feb"
 
 #: utils/dates.py:19
 msgid "mar"
-msgstr ""
+msgstr "mrt"
 
 #: utils/dates.py:19
 msgid "apr"
-msgstr ""
+msgstr "apr"
 
 #: utils/dates.py:19
 #, fuzzy
 msgid "may"
-msgstr "dag"
+msgstr "mei"
 
 #: utils/dates.py:19
 msgid "jun"
-msgstr ""
+msgstr "jun"
 
 #: utils/dates.py:20
 msgid "jul"
-msgstr ""
+msgstr "jul"
 
 #: utils/dates.py:20
 msgid "aug"
-msgstr ""
+msgstr "aug"
 
 #: utils/dates.py:20
 msgid "sep"
-msgstr ""
+msgstr "sep"
 
 #: utils/dates.py:20
 msgid "oct"
-msgstr ""
+msgstr "okt"
 
 #: utils/dates.py:20
 msgid "nov"
-msgstr ""
+msgstr "nov"
 
 #: utils/dates.py:20
 msgid "dec"
-msgstr ""
+msgstr "dec"
 
 #: utils/dates.py:27
 msgid "Jan."
@@ -1549,11 +1549,11 @@
 
 #: conf/global_settings.py:46
 msgid "Galician"
-msgstr "Galisisch"
+msgstr "Galicisch"
 
 #: conf/global_settings.py:47
 msgid "Hungarian"
-msgstr ""
+msgstr "Hongaars"
 
 #: conf/global_settings.py:48
 msgid "Hebrew"
@@ -1609,7 +1609,7 @@
 
 #: conf/global_settings.py:61
 msgid "Ukrainian"
-msgstr "Ukraiens"
+msgstr "Oekraïens"
 
 #: conf/global_settings.py:62
 msgid "Simplified Chinese"
@@ -1628,16 +1628,16 @@
 "This value must contain only letters, numbers, underscores, dashes or "
 "slashes."
 msgstr ""
-"Deze waarde mag alleen letters, cijfers,  liggende strepen en schuine "
+"Deze waarde mag alleen letters, cijfers, liggende strepen en schuine "
 "strepen bevatten."
 
 #: core/validators.py:72
 msgid "Uppercase letters are not allowed here."
-msgstr "Hoofdletters niet toegestaan."
+msgstr "Hoofdletters zijn hier niet toegestaan."
 
 #: core/validators.py:76
 msgid "Lowercase letters are not allowed here."
-msgstr "Kleine letters niet toegestaan."
+msgstr "Kleine letters zijn hier niet toegestaan."
 
 #: core/validators.py:83
 msgid "Enter only digits separated by commas."
@@ -1645,7 +1645,7 @@
 
 #: core/validators.py:95
 msgid "Enter valid e-mail addresses separated by commas."
-msgstr "Geef een geldig e-mail adres gescheiden door komma's."
+msgstr "Geef een geldig e-mailadres gescheiden door komma's."
 
 #: core/validators.py:99
 msgid "Please enter a valid IP address."
@@ -1653,11 +1653,11 @@
 
 #: core/validators.py:103
 msgid "Empty values are not allowed here."
-msgstr "Lege waarden niet toegestaan."
+msgstr "Lege waarden zijn hier niet toegestaan."
 
 #: core/validators.py:107
 msgid "Non-numeric characters aren't allowed here."
-msgstr "Niet-numerieke karakters niet toegestaan."
+msgstr "Niet-numerieke karakters zijn niet toegestaan."
 
 #: core/validators.py:111
 msgid "This value can't be comprised solely of digits."
@@ -1665,27 +1665,27 @@
 
 #: core/validators.py:116
 msgid "Enter a whole number."
-msgstr "Geef geheel getal."
+msgstr "Geef een geheel getal."
 
 #: core/validators.py:120
 msgid "Only alphabetical characters are allowed here."
-msgstr "Alleen alfabethische karakters zijn toegestaan"
+msgstr "Alleen alfabetische karakters zijn toegestaan"
 
 #: core/validators.py:124
 msgid "Enter a valid date in YYYY-MM-DD format."
-msgstr "Geef een geldige datum in JJJJ-MM-DD formaat."
+msgstr "Geef een geldige datum in jjjj-mm-dd formaat."
 
 #: core/validators.py:128
 msgid "Enter a valid time in HH:MM format."
-msgstr "Geef een geldige tijd in HH:MM formaat."
+msgstr "Geef een geldige tijd in uu:mm formaat."
 
 #: core/validators.py:132 db/models/fields/__init__.py:468
 msgid "Enter a valid date/time in YYYY-MM-DD HH:MM format."
-msgstr "Geef geldige datum/tijd in JJJJ-MM-DD HH:MM formaat."
+msgstr "Geef geldige datum/tijd in jjjj-mm-dd uu:mm formaat."
 
 #: core/validators.py:136
 msgid "Enter a valid e-mail address."
-msgstr "Geef geldig e-mail adres."
+msgstr "Voer een geldig e-mailadres in."
 
 #: core/validators.py:148
 msgid ""
@@ -1757,7 +1757,7 @@
 
 #: core/validators.py:255
 msgid "Please enter something for at least one field."
-msgstr "Geef in minimaal een veld een waarde."
+msgstr "Voer tenminste één veld in."
 
 #: core/validators.py:264 core/validators.py:275
 msgid "Please enter both fields or leave them both empty."
@@ -1775,7 +1775,7 @@
 
 #: core/validators.py:313
 msgid "Duplicate values are not allowed."
-msgstr "Dubbele waarden niet toegestaan."
+msgstr "Dubbele waarden zijn niet toegestaan."
 
 #: core/validators.py:336
 #, python-format
@@ -1791,26 +1791,26 @@
 msgid "Please enter a valid decimal number with at most %s total digit."
 msgid_plural ""
 "Please enter a valid decimal number with at most %s total digits."
-msgstr[0] "Geef een geldig decimaal getal met maximaal %s cijfer."
-msgstr[1] "Geef een geldig decimaal getal met maximaal %s cijfers."
+msgstr[0] "Geef een geldig decimaal getal met hooguit %s cijfer."
+msgstr[1] "Geef een geldig decimaal getal met hooguit %s cijfers."
 
 #: core/validators.py:352
 #, python-format
 msgid "Please enter a valid decimal number with at most %s decimal place."
 msgid_plural ""
 "Please enter a valid decimal number with at most %s decimal places."
-msgstr[0] "Geef een decimaal getal met maximaal %s cijfer achter de komma."
-msgstr[1] "Geef een decimaal getal met maximaal %s cijfers achter de komma."
+msgstr[0] "Geef een decimaal getal met hooguit %s cijfer achter de komma."
+msgstr[1] "Geef een decimaal getal met hooguit %s cijfers achter de komma."
 
 #: core/validators.py:362
 #, python-format
 msgid "Make sure your uploaded file is at least %s bytes big."
-msgstr "Zorg ervoor dat het bestand minimaal %s bytes groot is."
+msgstr "Zorg ervoor dat het bestand minstens %s bytes groot is."
 
 #: core/validators.py:363
 #, python-format
 msgid "Make sure your uploaded file is at most %s bytes big."
-msgstr "Zorg ervoor dat het bestand maximaal %s bytes groot is."
+msgstr "Zorg ervoor dat het bestand hoogstens %s bytes groot is."
 
 #: core/validators.py:376
 msgid "The format for this field is wrong."
@@ -1914,11 +1914,11 @@
 
 #: db/models/fields/__init__.py:385
 msgid "This field cannot be null."
-msgstr "Dit veld kan niet oningevuld zijn."
+msgstr "Dit veld kan niet leeg zijn."
 
 #: db/models/fields/__init__.py:562
 msgid "Enter a valid filename."
-msgstr "Geef geldige bestandsnaam."
+msgstr "Geef een geldige bestandsnaam."
 
 #: db/models/fields/related.py:43
 #, python-format
@@ -1941,15 +1941,15 @@
 msgid "Please enter valid %(self)s IDs. The value %(value)r is invalid."
 msgid_plural ""
 "Please enter valid %(self)s IDs. The values %(value)r are invalid."
-msgstr[0] "Geef een geldig %(self)s IDs. De waarde %(value)r is ongeldig."
-msgstr[1] "Geef een geldig %(self)s IDs. de waarden %(value)r zijn ongeldig."
+msgstr[0] "Geef een geldig %(self)s ID's. De waarde %(value)r is ongeldig."
+msgstr[1] "Geef een geldig %(self)s ID's. De waarden %(value)r zijn ongeldig."
 
 #: forms/__init__.py:380
 #, python-format
 msgid "Ensure your text is less than %s character."
 msgid_plural "Ensure your text is less than %s characters."
-msgstr[0] "Zorg ervoor dat uw tekst korter is dan %s."
-msgstr[1] "Zorg ervoor dat uw tekst korter is dan %S."
+msgstr[0] "Zorg ervoor dat uw tekst korter is dan %s karakter."
+msgstr[1] "Zorg ervoor dat uw tekst korter is dan %s karakters."
 
 #: forms/__init__.py:385
 msgid "Line breaks are not allowed here."
@@ -1966,15 +1966,15 @@
 
 #: forms/__init__.py:699
 msgid "Enter a whole number between -32,768 and 32,767."
-msgstr "Geef geheel getal tussen -32.768 en 32.767."
+msgstr "Geef een geheel getal tussen -32.768 en 32.767."
 
 #: forms/__init__.py:708
 msgid "Enter a positive number."
-msgstr "Geef geheel getal."
+msgstr "Geef een geheel getal."
 
 #: forms/__init__.py:717
 msgid "Enter a whole number between 0 and 32,767."
-msgstr "Geef geheel getal tussen 0 en 32.767."
+msgstr "Geef een geheel getal tussen 0 en 32.767."
 
 #: template/defaultfilters.py:379
 msgid "yes,no,maybe"